from _typeshed import Incomplete
from strictyaml.dumper import StrictYAMLDumper as StrictYAMLDumper
from strictyaml.exceptions import (
    YAMLSerializationError as YAMLSerializationError,
    raise_type_error as raise_type_error,
)
from strictyaml.ruamel import dump as dump, scalarstring as scalarstring
from strictyaml.ruamel.comments import (
    CommentedMap as CommentedMap,
    CommentedSeq as CommentedSeq,
)
from strictyaml.validators import Validator
from strictyaml.yamllocation import YAMLChunk as YAMLChunk
from typing import Any, Union

_YAMLIndex = Union["YAML", str, int]  # TODO: WIP

class YAMLIterator:
    def __init__(self, yaml_object: "YAML") -> None: ...
    def __iter__(self) -> "YAMLIterator": ...
    def next(self) -> "YAML": ...
    def __next__(self) -> "YAML": ...

class YAML:
    def __init__(self, value, validator: Incomplete | None = ...) -> None: ...
    def __int__(self) -> int: ...
    def __unicode__(self): ...
    def revalidate(self, schema: Validator) -> None: ...
    @property
    def data(self) -> Any: ...
    def as_marked_up(self): ...
    @property
    def start_line(self): ...
    @property
    def end_line(self): ...
    def lines(self): ...
    def lines_before(self, how_many): ...
    def lines_after(self, how_many): ...
    def __float__(self) -> float: ...
    def __bool__(self) -> bool: ...
    def __nonzero__(self): ...
    def __getitem__(self, index: _YAMLIndex) -> "YAML": ...
    def __setitem__(self, index: _YAMLIndex, value) -> None: ...
    def __delitem__(self, index: _YAMLIndex) -> None: ...
    def __hash__(self): ...
    def __len__(self) -> int: ...
    def as_yaml(self): ...
    def items(self): ...
    def keys(self): ...
    def values(self): ...
    def get(self, index: _YAMLIndex, default: Incomplete | None = ...): ...
    def __contains__(self, item) -> bool: ...
    def __iter__(self) -> YAMLIterator: ...
    @property
    def validator(self): ...
    @property
    def text(self): ...
    def copy(self): ...
    def __gt__(self, val): ...
    def __lt__(self, val): ...
    @property
    def value(self): ...
    def is_mapping(self) -> bool: ...
    def is_sequence(self) -> bool: ...
    def is_scalar(self) -> bool: ...
    @property
    def scalar(self): ...
    def whole_document(self): ...
    def __eq__(self, value): ...
    def __ne__(self, value): ...
